#include "ax1838hs.h"
#include <IRremote.h>

boolean started = false;
int remoteCode = 0;
IRrecv irrecv(0);

int dump(decode_results *results);
String decode(int param);

Ax1838hs::Ax1838hs(){
}

boolean Ax1838hs::mBlockRemoteKeyPressed(int pin,String key) {
	String keyPressed;
	keyPressed = decode(readCode(pin));
	if (keyPressed==key) {
		return true;
	} else {
		return false;
	}
}

int Ax1838hs::readCode(int pin){
  int code = 0;
  decode_results results;

 
  
  if (started==false) {
    IRrecv irrecv(pin);
    irrecv.enableIRIn();
    started=true;
  }
      
     
  if (irrecv.decode(&results)) {
    code = dump(&results);
    if (code!=-1) {
      remoteCode = code;
    }
    
    irrecv.resume();
    irrecv.resume();
  }  else {
   
    remoteCode = 0;
  }

  return remoteCode;
}

int dump(decode_results *results) {
  int code = 0;
 
  code = results->value;
  
  return code;
}

String decode(int param) {
  switch (param) {
          case -23971:
            return "A";
          break;
          case 25245:
            return "B";
          break;
          case -7651:
            return "C";
          break;
          case 8925:
            return "D";
          break;
          case -15811:
            return "E";
          break;
          case -20401:
            return "F";
          break;
          case 765:
            return "UP";
          break;
          case -26521:
            return "DOWN";
          break;
          case -8161:
            return "LEFT";
          break;
          case -28561:
            return "RIGHT";
          break;
          case -22441:
            return "SETUP";
          break;
          case 26775:
            return "0";
          break;
          case 12495:
            return "1";
          break;
          case 6375:
            return "2";
          break;
          case 31365:
            return "3";
          break;
          case 4335:
            return "4";
          break;
          case 14535:
            return "5";
          break;
          case 23205:
            return "6";
          break;
          case 17085:
            return "7";
          break;
          case 19125:
            return "8";
          break;
          case 21165:
            return "9";
          break;
          default:
          return "";
	} 
}


