#include "dht11.h"
#include <dht11.h>

dht11 DHT;

Dht11::Dht11(){
}

float Dht11::readTemperature(int pin){
  float temperature;
  int chk;
  
  chk = DHT.read(pin);    // READ DATA

  switch (chk){
    case DHTLIB_OK:  
                break;
    case DHTLIB_ERROR_CHECKSUM: 
                Serial.print("Checksum error,\t"); 
                return -1000;
                break;
    case DHTLIB_ERROR_TIMEOUT: 
                Serial.print("Time out error,\t"); 
                return -1000;
                break;
    default: 
                Serial.print("Unknown error,\t"); 
                return -1000;
                break;
  }

  temperature = DHT.temperature;
    
  return temperature;	
}

float Dht11::readHumidity(int pin){
 float humidity;
  int chk;
  
  chk = DHT.read(pin);    // READ DATA

  switch (chk){
    case DHTLIB_OK:  
                break;
    case DHTLIB_ERROR_CHECKSUM: 
                Serial.print("Checksum error,\t"); 
                return -1000;
                break;
    case DHTLIB_ERROR_TIMEOUT: 
                Serial.print("Time out error,\t"); 
                return -1000;
                break;
    default: 
                Serial.print("Unknown error,\t"); 
                return -1000;
                break;
  }

  humidity = DHT.humidity;
    
  return humidity;  
}
